﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Specialized;
using System.Collections.Generic;
using Com.Alipay;

/// <summary>
/// 功能：页面跳转同步通知页面
/// 版本：3.3
/// 日期：2012-07-10
/// 说明：
/// 以下代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写,并非一定要使用该代码。
/// 该代码仅供学习和研究支付宝接口使用，只是提供一个参考。
/// 
/// ///////////////////////页面功能说明///////////////////////
/// 该页面可在本机电脑测试
/// 可放入HTML等美化页面的代码、商户业务逻辑程序代码
/// 该页面可以使用ASP.NET开发工具调试，也可以使用写文本函数LogResult进行调试
///function:Server asynchronous notification page
///version:3.3
///modify date：2012-08-17
///instruction:
///This code below is a sample demo for merchants to do test.Merchants can refer to the integration documents and write your own code to fit your website.Not necessarily to use this code.  
///Alipay provide this code for you to study and research on Alipay interface, just for your reference.

/// ///////////////////function description///////////////////
/// This page can be tested locally.
/// You can add HTML code and so forth to beautify the page.You can add program code of your business logic  too.
/// You can use debug tool of ASP.NET, alternatively you can use the function logResult to write the log

/// </summary>
public partial class return_url : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        SortedDictionary<string, string> sPara = GetRequestGet();

        if (sPara.Count > 0)//判断是否有带返回参数check whether there's any para
        {
            Notify aliNotify = new Notify();
            //bool verifyResult = aliNotify.VerifyReturn(sPara, Request.QueryString["sign"]);

            bool verifyResult=aliNotify.verifyResult(sPara, sign.replace(' ','+'));//usd for resolving the issue "The RSA signature returned is not urlencoded"

            if (verifyResult)//验证成功 verification is succeeded
            {
                /////////////////////////////////////////////////////////////////////////////////////////////////////////////
                //请在这里加上商户的业务逻辑程序代码
				//Please add yourprogram code here according to your business logic.


                //——请根据您的业务逻辑来编写程序（以下代码仅作参考）——
                //获取支付宝的通知返回参数，可参考技术文档中页面跳转同步通知参数列表
				//——Please write program according to your business logic.(The below code is for your reference.)
			    //Get the returned parameters from notification.You can refer to alipay's notification parameters list in integration documents.

                //商户订单号

				//out_trade_no				
                string out_trade_no = Request.QueryString["out_trade_no"];

                //支付宝交易号

				//trade_no
                string trade_no = Request.QueryString["trade_no"];

                //交易状态
				//trade_status
                string trade_status = Request.QueryString["trade_status"];


                if (Request.QueryString["trade_status"] == "TRADE_FINISHED" || Request.QueryString["trade_status"] == "TRADE_SUCCESS")
                {
                    //判断该笔订单是否在商户网站中已经做过处理
			//Check whether the order has been processed in the partner's website.				
                    //支付是否成功要以收到的notification的结果为准，不能以通过return的结果来定
					//To confirm whether a payment is succeed,you should not judge based on the return
                }
                else
                {
                    Response.Write("trade_status=" + Request.QueryString["trade_status"]);
                }

                //打印页面print the page
                Response.Write("验证成功verification succeed<br />");

                //——请根据您的业务逻辑来编写程序（以上代码仅作参考）——
	            //—-Please write program according to your business logic.(The below code is for your reference.)

                /////////////////////////////////////////////////////////////////////////////////////////////////////////////
            }
            else//验证失败
            {
                Response.Write("验证失败fail");
            }
        }
        else
        {
            Response.Write("无返回参数No params");
        }
    }

    /// <summary>
    /// 获取支付宝GET过来通知消息，并以“参数名=参数值”的形式组成数组
	/// obtain the response message from Alipay servers by the way of GET .Connect params like"parameter=value" into an Array
    /// </summary>
    /// <returns>request回来的信息组成的数组Array from returned info</returns>
    public SortedDictionary<string, string> GetRequestGet()
    {
        int i = 0;
        SortedDictionary<string, string> sArray = new SortedDictionary<string, string>();
        NameValueCollection coll;
        //Load Form variables into NameValueCollection variable.
        coll = Request.QueryString;

        // Get names of all forms into a string array.
        String[] requestItem = coll.AllKeys;

        for (i = 0; i < requestItem.Length; i++)
        {
            sArray.Add(requestItem[i], Request.QueryString[requestItem[i]]);
        }

        return sArray;
    }
}
